"""
defend.py

The start script for the game. Run this.
"""

import time, sys

import pygame

pygame.init()
pygame.font.init()

import engine, input, objects, render

WIDTH = 768
HEIGHT = 576

hover = None
hover_tool = None

TIMESTEP = 0.1

def intercept(commands):
  global hover, hover_tool
  result = []
  for c in commands:
    if c == "quit":
      sys.exit(0)
    elif isinstance(c, tuple):
      if c[0] == "hover":
        hover = c[1]
      elif c[0] == "hover_tool":
        hover_tool = c[1]
      else:
        result.append(c)
    else:
      result.append(c)
  return result

if __name__ == "__main__":
  screen = pygame.display.set_mode((WIDTH, HEIGHT))
  while(True):
    state = engine.State()
    middle = (state.size[0]//2, state.size[1]//2)
    heartcell = state.get(*middle)
    while not input.get_advance():
        render.show_screen(screen, "title")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "last_human")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "humanity_is_gone")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "controls")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "pieces")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "buildings")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "howto")
        time.sleep(0.1)
    while not input.get_advance():
        render.show_screen(screen, "get_ready")
        time.sleep(0.1)
    while isinstance(heartcell["thing"], objects.Heart) \
      and state.stuff["quit"] == False:
      state.commands.extend(intercept(input.get_input()))
      attacks = state.advance()
      time.sleep(TIMESTEP/4)
      state.commands.extend(intercept(input.get_input()))
      render.render(screen, state, attacks, hover, hover_tool, 0)
      time.sleep(TIMESTEP/4)
      state.commands.extend(intercept(input.get_input()))
      render.render(screen, state, attacks, hover, hover_tool, 1)
      time.sleep(TIMESTEP/4)
      state.commands.extend(intercept(input.get_input()))
      render.render(screen, state, attacks, hover, hover_tool, 2)
      time.sleep(TIMESTEP/4)
      state.commands.extend(intercept(input.get_input()))
      render.render(screen, state, attacks, hover, hover_tool, 3)
    while not input.get_advance():
      render.show_high_score(screen, state.stuff["current_wave"])
      time.sleep(0.1)
