"""
waves.py

Defines enemy waves (sometimes procedurally).
"""

import random

import objects

def get(n):
  # Size of the waves:
  factor = n * 0.7
  if n > 8:
    factor = n * 0.9
  if n > 35:
    factor = n * 1.1
  size = 5 + factor
  if size > 74:
    size = 74
  size = int(size)
  distribution = 1.0 - min(1.0, (n / 20))
  bombchance = max(0, min(0.7, (n - 12) * 0.01))
  rb = int(size * distribution)
  db = size - rb
  bb = 0
  for i in range(db):
    if random.uniform(0, 1) < bombchance:
      db -= 1
      bb += 1

  # Timing of the waves:
  if n == 0:
    t = 15
  elif n == 1:
    t = 75
  elif n == 2:
    t = 65
  elif n in range(3, 12):
    t = 60 - (n - 3)
  elif n in range(12, 48):
    t = 51 - (n - 13)
  elif n in range(48, 60):
    t = 15 - (n // 6)
  else:
    t = 5

  return {
    "number": n,
    "timer": t,
    "contents":
      [objects.RamBot] * rb + [objects.DrillBot] * db + [objects.BombBot] * bb,
  }
